One use case for this experiment is to test Fedora's pytorch packages, this document describes how
to do that in a very basic way.

Note that this description will enable some reproduction of the posted but purposely doesn't cover
data collection or the experiment design.

## Prepare Environment
There are preparations needed for both code and data

### system preparation
1. Install the required packages for using pytorch:  `dnf install python3-torch python3-virtualenv python3-torchvision`.
1. clone the code `git clone https://pagure.io/fedora-qa/openqa_classifier`
1. change into the git checkout and create a virtualenv, maintaining system site packages
    -  `virtualenv --system-site-packages env_openqa`
1. activate the virtulalenv and install required python bits
    - `source env_openqa/bin/activate`
    - `pip install -r requirements.fedora_pytorch.txt`

### data preparation
1. download the data (1x is smaller and should work fine for testing)
    - https://infrastructure.fedoraproject.org/infra/fedora-openqa-data/20231116-openqa-2119970-composite_failures-1x-resolution.tar.xz

1. extract the data tarball to a local folder and note the location, it will be referred to as `DATA_DIR`. default is in `../openqa_data/` relative to the `openqa_classifier` checkout

### generate experiments
The openqa_classifier code is designed to generate many experiments that run over the same data with varying parameters. If you've extracted the dataset above to `../openqa_data`, run the following from the `openqa_classifier` checkout:

```
python -m openqa_classifier.tuning prep --dataset-name composite_failures_1x cnn_3_layer
```

This will generate experiment configurations in the `tuning_runs` directory

## Run An Experiment
You can run all the experiments, which can take quite a while.
```
python -m openqa_classifier.tuning run tuning_runs/<generated directory name>/
```

If you want to run a single experiment, choose an interation (example uses iteration-1 but any of
the generated experiments will work just as well)

```
python -m openqa_classifier.cli tuning_runs/<generated directory name>/iteration-1
```
