#  -*- coding: utf-8 -*-
# Copyright (c) 2023 Timothy Flink.
# License: GPL-3.0-or-later
# See the LICENSE file for more details on licensing
#
# This file is part of openqa_classifier
# (see https://pagure.io/fedora-qa/openqa_classifier).
#

import os
import sys

################################################################################
# move_rename_ogv.py
#
# This is a dumb script that I wrote to move the $JOBID/video.ogv files for each
# job to a different videos directory as $JOBID.ogv files
#
# I'm sure there are better ways to do this but this is the first thing I thought
# of and I'm rolling with it.
################################################################################


BASEDIR = os.path.abspath(sys.argv[1])
TARGETDIR = os.path.abspath(sys.argv[2])

if not os.path.isdir(BASEDIR):
    raise Exception("BASEDIR is not a dir: {}".format(BASEDIR))

with os.scandir(BASEDIR) as jobdirscan:
    for entry in jobdirscan:
        if entry.is_dir():
            video_filename = os.path.join(BASEDIR, entry.name, "video.ogv")
            new_video_filename = os.path.join(TARGETDIR, "{}.ogv".format(entry.name))

            if os.path.isfile(video_filename):
                print("moving {} to {}".format(video_filename, new_video_filename))
                os.rename(video_filename, new_video_filename)
            else:
                print("did not find a video file for job {}".format(entry.name))
