import numbers

from openqa_classifier import cli
from . import cli_support_data


class TestCli(object):

    def test_filter_desired_metrics(self):
        input_data = cli_support_data.hf_trainer_single_epoch_validation_metrics

        filtered_metrics = cli.filter_metrics_dict(input_data)

        assert len(filtered_metrics) == len(cli.desired_mean_metric_keys)
        for metric_name in filtered_metrics.keys():
            assert metric_name in cli.desired_mean_metric_keys
            assert isinstance(filtered_metrics[metric_name], numbers.Number)

    def test_process_validation_metrics(self):
        input_data = cli_support_data.hftrainer_2epoch_raw_validation_metrics

        processed_metrics = cli.process_validation_metrics(input_data)

        assert len(processed_metrics) == 2
        for epoch_metrics in processed_metrics:
            assert isinstance(epoch_metrics, dict)
            for metric_name in epoch_metrics.keys():
                assert metric_name in cli.desired_mean_metric_keys

    def test_calculate_mean_dict_metrics(self):
        input_data = cli_support_data.hftrainer_5epoch_listof_validation_metric_dicts

        mean_metrics = cli.calculate_mean_dict_metrics(input_data)

        assert len(mean_metrics) == len(cli.desired_mean_metric_keys)
        for metric_name in mean_metrics.keys():
            assert metric_name in cli.desired_mean_metric_keys
            assert isinstance(mean_metrics[metric_name], numbers.Number)
